; ==============================================================================
;	Memory Mapper
;
;  Copyright (C) 2020 Takayuki Hara (HRA!)
;  All rights reserved.
;                           http://hraroom.s602.xrea.com/msx/software/mgsp.html
;
;  {\tgEFAі{\tgEFAɊÂč쐬ꂽh́Aȉ̏
;  ꍇɌAĔЕzюgp܂B
;
;  1.\[XR[h`ōĔЕzꍇAL̒쌠\A{ꗗAщL
;    Ɛӏ̂܂܂̌`ŕێ邱ƁB
;  2.oCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
;    쌠\A{ꗗAщLƐӏ܂߂邱ƁB
;  3.ʂɂ鎖ŐȂɁA{\tgEFA̔AяƓIȐi⊈
;    ɎgpȂƁB
;
;  {\tgEFÁA쌠҂ɂāû܂܁v񋟂Ă܂B쌠҂́A
;  ړIւ̓K̕ۏ؁Ai̕ۏ؁A܂Ɍ肳ȂAȂ閾
;  I͈ÖقȕۏؐӔC܂B쌠҂́AR̂킸AQ
;  ̌킸AӔC̍_ł邩iӔCł邩iߎ
;  ̑́js@sׂł邩킸Aɂ̂悤ȑQ\m
;  ĂƂĂA{\tgEFA̎gpɂĔi֕i܂͑pT
;  [rX̒BAgp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂
;  Ɍ肳ȂjڑQAԐڑQAIȑQAʑQAIQA
;  ͌ʑQɂāAؐӔC𕉂Ȃ̂Ƃ܂B
;
;  Note that above Japanese version license is the formal document.
;  The following translation is only for reference.
;
;  Redistribution and use of this software or any derivative works,
;  are permitted provided that the following conditions are met:
;
;  1. Redistributions of source code must retain the above copyright
;     notice, this list of conditions and the following disclaimer.
;  2. Redistributions in binary form must reproduce the above
;     copyright notice, this list of conditions and the following
;     disclaimer in the documentation and/or other materials
;     provided with the distribution.
;  3. Redistributions may not be sold, nor may they be used in a
;     commercial product or activity without specific prior written
;     permission.
;
;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
;  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
;  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
;  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
;  POSSIBILITY OF SUCH DAMAGE.
; ------------------------------------------------------------------------------
;	Date		Author	Ver		Description
;	2020/9/22	t.hara	1.0		1st release
; ==============================================================================

; ==============================================================================
;	MapperSupportRoutine's table offset (This area is reference only)
; ==============================================================================
mmap_slot		:= 0			; 1byte, }bp[RAM̃Xbgԍ
mmap_total_seg	:= 1			; 1byte, ZOg
mmap_free_seg	:= 2			; 1byte, gpZOg
mmap_sys_seg	:= 3			; 1byte, VXeɊ蓖ĂꂽZOg
mmap_user_seg	:= 4			; 1byte, [U[Ɋ蓖ĂꂽZOg
mmap_reserved	:= 5			; 3byte, \̈

; ==============================================================================
;	mmap_init
;	input)
;		--
;	output)
;		Zf ................. 1: MemoryMapperT|[g[`݂Ȃ
;		[mmap_table_ptr] ... }bp[e[ũAhX
;	break)
;		all
; ==============================================================================
		scope	mmap_init
mmap_init::
		ld		a, [hokvld]
		and		a, 1
		ret		z				; gBIOS݂Ȃꍇ̓G[(Zf=1)

		; get MapperSupportRoutine's table
		xor		a, a
		ld		de, 0x0401		; D=MemoryMapperSupportRoutine ID, E=01h
		call	extbio
		or		a, a
		ret		z				; }bp[T|[g[`݂Ȃꍇ̓G[(Zf=1)
		ld		[mmap_table_ptr], hl

		; get jump table
		ld		de, 0x0402		; D=MemoryMapperSupportRoutine ID, E=02h
		call	extbio
		ld		de, mapper_jump_table
		ld		bc, 16 * 3
		ldir

		; get current segment on page1
		call		mapper_get_p1
		ld			[mapper_segment_p1], a
		call		mapper_get_p2
		ld			[mapper_segment_p2], a

		or		a, a
		inc		a
		ret						; I (Zf=0)
		endscope

; ==============================================================================
;	Xbg\ TPA ɖ߂
; ==============================================================================
		scope		mmap_change_to_tpa
mmap_change_to_tpa::
		; change slot of page1
		ld			h, 0x40
		ld			a, [ramad1]
		call		enaslt

		; change slot of page2
		ld			h, 0x80
		ld			a, [ramad2]
		call		enaslt

		; change mapper segment of page1
		ld			a, [mapper_segment_p1]
		call		mapper_put_p1

		; change mapper segment of page2
		ld			a, [mapper_segment_p2]
		call		mapper_put_p2
		ei
		ret
		endscope

; ==============================================================================
;		WORKAREA
; ==============================================================================
mmap_table_ptr::
		dw			0				; }bp[e[ũAhXi[
mapper_segment_p1:
		db			0				; N page1 ̃ZOgԍ
mapper_segment_p2:
		db			0				; N page2 ̃ZOgԍ

mapper_jump_table::
mapper_all_seg::	; +00h
		db			0xc9, 0xc9, 0xc9
mapper_fre_seg::	; +03h
		db			0xc9, 0xc9, 0xc9
mapper_rd_seg::		; +06h
		db			0xc9, 0xc9, 0xc9
mapper_wr_seg::		; +09h
		db			0xc9, 0xc9, 0xc9
mapper_cal_seg::	; +0Ch
		db			0xc9, 0xc9, 0xc9
mapper_calls::		; +0Fh
		db			0xc9, 0xc9, 0xc9
mapper_put_ph::		; +12h
		db			0xc9, 0xc9, 0xc9
mapper_get_ph::		; +15h
		db			0xc9, 0xc9, 0xc9
mapper_put_p0::		; +18h
		db			0xc9, 0xc9, 0xc9
mapper_get_p0::		; +1Bh
		db			0xc9, 0xc9, 0xc9
mapper_put_p1::		; +1Eh
		db			0xc9, 0xc9, 0xc9
mapper_get_p1::		; +21h
		db			0xc9, 0xc9, 0xc9
mapper_put_p2::		; +24h
		db			0xc9, 0xc9, 0xc9
mapper_get_p2::		; +27h
		db			0xc9, 0xc9, 0xc9
mapper_put_p3::		; +2Ah
		db			0xc9, 0xc9, 0xc9
mapper_get_p3::		; +2Dh
		db			0xc9, 0xc9, 0xc9
